<template>
    <div>
        <div class="white-block">
            <div class="padding">
                <h3>Подписание договора</h3>
            </div>
            <hr>
            <div class="padding loan-signing">
                <p>Для подписания договора введите код подтверждения из SMS.</p>
                <div class="row">
                    <div class="columns six">
                        <label for="sms-code">Код из СМС:</label>
                        <input v-model="smsCode"
                               v-validate="'required|length:4'"
                               v-mask="'####'"
                               name="для ввода СМС кода"
                               id="sms-code"
                               :class="getValidateClass('для ввода СМС кода')"
                               placeholder="Введите код сюда"
                               type="tel"
                               ref="smsCode"
                        >
                        <validate-message style="margin-top: 1px"
                                          v-show="vErrors.has('для ввода СМС кода')">
                            {{ vErrors.first('для ввода СМС кода') }}
                        </validate-message>
                    </div>
                </div>
                <div class="row">
                    <div class="columns six">
                        <a v-if="smsCountDown" class="refresh" :class="{rotate: loading}">Выслать код повторно через {{smsCountDown}} {{$helpers.plural(smsCountDown, ['секунду', 'секунды', 'секунд'])}}</a>
                        <a v-else @click="resendSms" class="refresh after-time">Выслать код повторно</a>
                    </div>
                </div>
                <div class="row">
                    <div class="checkbox">
                        <div class="ui-checkbox">
                            <ui-checkbox v-model="agree"></ui-checkbox>

                            <p class="agreement">
                                Вводя код подтверждения, вы принимаете
                                <span class="link" @click="loanAgreement">условия договора.</span>
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <button @click="sign"
                :disabled="!agree || $interface.buttonLoading || parseInt(smsCode).toString().length !== 4"
                :class="{button_loading: $interface.buttonLoading}"
        >Подписать</button>
    </div>

</template>

<script>
  import validateMixin from '@/mixins/Validation/GetValidateClassMixin';
  import smsErrors from '@/utils/error_mapper/smsErrors';

  export default {
    name: 'AmnestySign',
    mixins: [validateMixin],
    data () {
      return {
        smsCountDown: 0,
        loading: false,
        smsCode: null,
        agree: true
      }
    },

    created () {
        this.$on('focus', () => {
          this.$refs.smsCode.focus();
          this.$helpers.scroll(this.$el);
        })
    },


    methods: {
      resendSms () {
        if(this.loading) return;

        this.loading = true;
        this.$backend.getData('supplementary/amnesty/sign/resend').then(() => {
          this.$toastr.success('СМС с кодом выслано на ваш номер телефона', 'Успешно');
          this.smsCountDown = 60;
          this.startCountDown();
        }).catch((e) => {
          this.$error(e, smsErrors, 'Не удалось отправить СМС.');
        }).finally(() => {
          this.loading = false;
        })
      },


      startCountDown () {
        setTimeout(() => {
          this.smsCountDown-= 1;
          if(this.smsCountDown) {
            this.startCountDown();
          }
        }, 1000);
      },


      sign () {
        this.BUTTON_LOADING(true);
        this.$backend.postData('supplementary/amnesty/sign', {
          smsCode: this.smsCode
        }).then(() => {
            this.$toastr.success('Доп.соглашение об амнистии успешно подписано. Оплатите его.', 'Успешно');
            this.$pdl.supplementary.amnesty.status = 2;
        }).catch((e) => {
            this.$error(e,  smsErrors, 'Ошибка подписания договора');
        }).finally(() => {
          this.BUTTON_LOADING(false);
        })
      },


      loanAgreement () {
        const win = window.open('about:blank', 'target=_blank', 'status=0,title=0,height=600,width=1000,scrollbars=1')
        this.$backend.getData(`documents/supplementary/html/${this.$pdl.id}/${this.$pdl.supplementary.amnesty.id}`).then(res => {
          this.documentNumber = res.data
          win.document.write(this.documentNumber)
        }).catch((e) => {
          console.warn(e);
        })
      }
    }
  }
</script>

<style scoped lang="scss">
    button.link {
        color: #1EAEDB;
        text-decoration: underline;
        padding: 0;
        margin: 0;
        background: none;
        font-size: inherit;
        font-weight: normal;
        letter-spacing: normal;
        text-transform: none;
        height: 16px;
    }

    div.checkbox {
        margin-top: 20px;
    }
    p.agreement {
        font-size: 14px !important;
        padding-top: 0;
    }
    span.checkmark {
        margin-top: 20px;
    }
</style>
